/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : back_stat.cc
Last edit : 10/20/92
Created   :
Version   : 1.3

History   :

Does      :
*/ 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curses.h>

#include <paths.h>
#include <ruutu.h>
#include <mcform.h>
#include <limits.h>

#include "../stats/st.h"
#include "../stats/stat.h"
#include "../race/race_main.h"
#include "../profe/profe_mai.h"

#include "special.h"
#include "item.h"

static role_stat rstats;

extern "C" { char *mstrtok(char *, char*); };

int get_points(char *name)
{
  struct race_main race;
  FILE *src = NULL;
  int p=0;

  src = fopen(name,"r");
  if(!src) {
    perror("Sorry, couldn't load your char");
    exit(0);
  }
  fread(&race,sizeof(struct race_main),1,src);
  fclose(src);
  p = race.bag;
  rstats.enter_racial(0,race.co);
  rstats.enter_racial(1,race.sd);
  rstats.enter_racial(2,race.ag);
  rstats.enter_racial(3,race.mq);
  rstats.enter_racial(4,race.re);
  rstats.enter_racial(5,race.st);
  rstats.enter_racial(6,race.qu);
  rstats.enter_racial(7,race.pr);
  rstats.enter_racial(8,race.in);
  rstats.enter_racial(9,race.em);
  free(name);
  return p;
}

char *get_primes(char *name)
{
  struct profe_mai profe;
  FILE *src = NULL;
  int p=0;
  char *primes;

  src = fopen(name,"r");
  if(!src) {
    perror("Sorry, couldn't load your char");
    exit(0);
  }
  fread(&profe,sizeof(struct profe_mai),1,src);
  fclose(src);
  primes = strdup(profe.prime);
  return primes;
}
  
int fetch_stats(char *arg)  
{
  char *directory=NULL;
  int len = 0;
  char *name=NULL;
  char *primes;
  int p=0;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    perror("back_stat.cc/strtok");
    exit(0);
  }

  len = 2 * strlen(directory) + strlen(SAVE) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("malloc");
    exit(0);
  }
  sprintf(name,"%s/%s/%s.profe",SAVE,directory,directory);
  primes = get_primes(name);
  sprintf(name,"%s/%s/%s.stats",SAVE,directory,directory);
  rstats.load(name);
  rstats.primes(primes);
  sprintf(name,"%s/%s/%s.race",SAVE,directory,directory);
  p = get_points(name);
  return p;
}

int back_stat(int lkm)
{
  int amount = 1;
  int found = 0;
  int stbr[3]={-1,-1,-1};
  int ok=0;
  int j=0;
  int i=0;
  char *a=NULL;
  char *t=NULL;
  int koodi = 0;
  int str;
  int error=0;

  amount = lkm == 3 ? 1:2;

  addch(' ');
  refresh();
  clear();
  refresh();
  rstats.print();

  while(!ok) {
    move(21,1);
    if(amount == 3)
      printw("Enter stats to be risen:");
    else
      printw(" Enter stat to be risen:");

    refresh();
    a = get_string(26,21,12,&koodi,0,NULL);
    move(21,1);
    clrtoeol();
    refresh();	
    if(koodi == KEY_EXIT) {
      ok = 1;
      continue;
    };
    t = mstrtok(a," ,\n\0");
    while(t) {
      str = 0;	
      if(!strcmp(t,"CO"))
        str = 1;
      if(!strcmp(t,"SD"))
        str = 2;
      if(!strcmp(t,"AG"))
        str = 3;
      if(!strcmp(t,"MQ"))
        str = 4;
      if(!strcmp(t,"RE"))
        str = 5;
      if(!strcmp(t,"ST"))
        str = 6;
      if(!strcmp(t,"QU"))
        str = 7;
      if(!strcmp(t,"PR"))
        str = 8;
      if(!strcmp(t,"IN"))
        str = 9;
      if(!strcmp(t,"EM"))
        str = 10;
      if(str) 
        stbr[found++] = str -1;
      for(i=0;i < found;i++)
        for(j=i+1; j < found; j++)
          if(stbr[i] == stbr[j]) 
	    error = 1;
      if(error) {
        move(21,1);
	printw("Error in stat-string. Press a key.");
	refresh();
	getch();
	move(21,1);
	clrtoeol();
	refresh();
	error = 0;
	break;
      }	
      t = mstrtok(NULL," ,\n\0");
    }
    ok = 1;
    move(21,1);
    clrtoeol();
    if(found != lkm) {
      move(21,1);
      printw("Wrong number stats entered. Press a key.");
      refresh();
      getch();
      move(21,1);
      clrtoeol();
      ok = 0;
      found = 0;	
    }
  }
  for(i=0;i<found;i++)
    rstats.raise_one(stbr[i],amount);
  rstats.bonus();
  rstats.count_totals();
  rstats.statistics();
  rstats.print();
  move(21,1);
  printw("Press any key to continue!");
  refresh();
  getch();  
  return 0;
}

void misc_s_bonus(int s, int b)
{
  rstats.enter_misc(s,b);
  rstats.count_totals();
  clear();
  refresh();
  rstats.print();
  move(23,0);
  printw("Press any key to continue!\n");
  refresh();
  getch();
  clear();
  refresh();
  return;
}

void save_background(char *arg, struct item *l, struct special *ls, int lang, int rands, int gold)
{
  char *directory=NULL;
  int len = 0;
  char *name=NULL;
  char *primes;
  int p=0;
  struct item *t=NULL;
  struct special *ts;
  int lkm=0;
  FILE *dst;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    perror("back_stat.cc/strtok");
    exit(0);
  }

  len = 2 * strlen(directory) + strlen(SAVE) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("malloc");
    exit(0);
  }

  sprintf(name,"%s/%s/%s.fstats",SAVE,directory,directory);
  rstats.save(name);

  sprintf(name,"%s/%s/%s.backg",SAVE,directory,directory);
  dst = fopen(name,"w");
  if(!dst) {
    move(20,0);
    printw("Sorry, couldn't save character, press a key.");
    refresh();
    getch();
    move(20,0);
    clrtoeol();
    return;
  }
  lkm = 0;
  putw(lang,dst);
  putw(rands,dst);
  putw(gold,dst);

  t = l;
  while(t) {
   lkm++;
   t=t->next;
  };
  putw(lkm,dst);
  lkm = 0;
  ts = ls;
  while(ts) {
    lkm++;
    ts=ts->next;
  };
  t = l;
  putw(lkm,dst);
  while(t) {
    l = t->next;
    fwrite(t,sizeof(struct item),1,dst);
    free(t);
    t = l;
  };
  ts = ls;
  while(ts) {
    ls =ts->next;
    fwrite(ts,sizeof(struct special),1,dst);
    free(ts);
    ts = ls;
  };
  fclose(dst);
  move(20,0);
  printw("Background saved, press any key to continue.");
  refresh();
  getch();
  move(20,0);
  clrtoeol();
  return;
}

