/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : list.c
Last edit : 10/20/92
Created   :
Version   : 1.2

History   :

Does      :
*/
#include <curses.h>

#include <limits.h>
#include "chosen.h"

/* Haetaan listasta edelt{j{ tai exact match. */
OS_CHOSEN find_one(int nro, OS_CHOSEN lst)
{
  OS_CHOSEN t=NULL;

  if(!(t=lst))			/* Ei listaa. */
    return t;
 
  while(t && (t->nro < nro))	/* Niin kauan kuin on listaa ja nro > */
    t = t->seur;

  return t;			/* Palautetaan seuraaja tai exact match. */
}
 
/* List{{n listaan yksi. */
OS_CHOSEN add_one_skill(OS_CHOSEN new, OS_CHOSEN lst)
{
  OS_CHOSEN t;

  if(!new)			/* Ei uutta alkiota. */
    return lst;

  new->edel = NULL;
  new->seur = NULL;

  if(!lst)			/* Ei vanhaa listaa, uusi on lista. */	
    return new;

  t = find_one(new->nro, lst);	/* Haetaan seuraaja. */

  if(t) {			/* Seuraaja on olemassa. */
    if(t->nro == new->nro) {	/* Onko seuraajan numero sama? */
      t->num++;			/* On, lis{t{{n viittauksia. */
      free(new);		/* Vapautetaan uusi alkio. */
      return lst;		/* Palautetaan lista. */
    }
    new->seur = t;		/* Uuden seuraaja. */
    new->edel = t->edel;	/* Uuden edelt{j{. */
    
    if(new->edel)		/* Oliko? */
      new->edel->seur = new;	/* Edelt{j{n seuraaja = lis{tty. */

    if(t == lst)
      lst = new;
    return lst;			/* Palautetaan lista. */
  }
  t = lst;			/* Haetaan listan loppu. */
  while(t->seur) t = t->seur;

  t->seur = new;		/* Listan vika = uusi. */
  new->edel = t;		/* Uuden edelt{j{ = listan vanha vika. */
  return lst;			/* Lista takaisin. */
}

OS_CHOSEN remove_one(int nro, OS_CHOSEN lst)
{
  OS_CHOSEN t=NULL;

  t = find_one(nro, lst);	/* Haetaan listasta. */

  if(!t)			/* Ei l|ytynyt. */
    return lst;

  if(t->nro != nro)		/* Ei l|ytynyt. */
    return lst;

  t->num--;

  if(t->num)			/* V{hennet{{n viittauksia. */
    return lst;			/* J{i viittauksia. */

  if(t->edel)			/* P{ivitet{{n edelt{j{. */
    t->edel->seur = t->seur;

  if(t->seur)			/* P{ivitet{{n seuraaja. */
    t->seur->edel = t->edel;

  if(t == lst)			/* P{ivitet{{n listan alku. */
    lst = t->seur ? t->seur : t->edel;

  free(t);

  return lst;
}

int num_of_chosen(int nro, OS_CHOSEN lst)
{
  OS_CHOSEN t;

  t = find_one(nro, lst);

  if(!t) 
    return 0;

  if(t->nro == nro)
    return t->num;
  else
    return 0;
}


void dump_list(OS_CHOSEN lst)
{
  OS_CHOSEN t;
  int i=0;

  clear();
  refresh();

  t = lst;
  while(t) {  
    printw("Skill : %s\n",t->skill);
    printw("Numero: %i\n",t->nro);
    printw("Kpl   : %i\n",t->num);
    printw("Cost  : %i/%i/%i\n",t->costa,t->costb,t->costc);
    printw("Ranks : %i\n",t->ranks);
    printw("Lvl   : %i\n",t->lvl);
    i+=6;	
    refresh();
    t=t->seur;
    if(!(i % 24)) 
      getch();	
  }
  getch();
}
  
OS_CHOSEN load_skill_lst(char *name)
{
  OS_CHOSEN n=NULL;
  OS_CHOSEN lst=NULL;
  FILE *src = NULL;

  src = fopen(name,"r");
  if(!src)
    return NULL;

  while(!feof(src)) {
    n = (OS_CHOSEN)calloc(1,sizeof(CHOSEN));
    if(!n) {
      perror("list.c/calloc.c");
      exit(0);
    };

    if(fread(n,sizeof(CHOSEN),1,src)==1)
      lst = add_one_skill(n,lst);
    else
      free(n);
 };
 
 fclose(src);
 return lst;
}

void save_skill_lst(char *name, OS_CHOSEN lst)
{
  OS_CHOSEN n=NULL;
  FILE *src = NULL;

  src = fopen(name,"w");
  if(!src)
    return;

  n = lst;
  while(n) {
    lst = n;
    fwrite(n,sizeof(CHOSEN),1,src);
    n = n->seur;
    free(lst);
  };
 
 fclose(src);
 return;
}

int count_skills(OS_CHOSEN lst)
{
  int lkm=0;
  OS_CHOSEN t;

  t = lst;
  while(t) {
    t=t->seur;
    lkm++;
  }

  return lkm;
}
 
